//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "acCaptionButton"
#pragma link "acClasses"
#pragma link "acComCtrls"
#pragma link "acEdit"
#pragma link "acExtAssociation"
#pragma link "acFormHelp"
#pragma link "acFormMagnet"
#pragma link "acFormPlacementSaver"
#pragma link "acSendMail"
#pragma link "acStatusControl"
#pragma link "acSystemInfo"
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
#define REG_SAVE        "\\Software\\Utilmind Solutions\\SendMailDemo";

void __fastcall TForm1::FixButtonState()
{
  AbortBtn->Enabled = acSendMail1->Busy;
  SendBtn->Enabled = !(AbortBtn->Enabled);
}  

void __fastcall TForm1::PrepareSendMail()
{
  acSendMail1->SMTPHost = SMTPHostEdit->Text;
  acSendMail1->SMTPPort = SMTPPortEdit->Value;

  acSendMail1->FromAddress = FromAddressEdit->Text;
  acSendMail1->FromName = FromNameEdit->Text;
  acSendMail1->FromOrganization = FromCompanyEdit->Text;
  acSendMail1->ToAddr = ToEdit->Text;
  acSendMail1->ToCC   = CCEdit->Text;
  acSendMail1->ToBCC  = BCCEdit->Text;

  acSendMail1->MsgSubject = SubjectEdit->Text;
  acSendMail1->MsgBody    = Memo1->Text;
  acSendMail1->MsgContentCharset = CharsetEdit->Text;
  if (PlainBox->Checked)
    acSendMail1->MsgContentType = ctPlainText;
  else
    acSendMail1->MsgContentType = ctHTML;
    
  acSendMail1->MsgPriority = ((TacSMTPPriority)PriorityBox->ItemIndex);

  if (AttachTypeBox->Checked)
    acSendMail1->AttachType = atEmbedded;
  else
    acSendMail1->AttachType = atNormal;
}

void __fastcall TForm1::LoadSettings()
{
  TRegistry  *Reg;
  AnsiString Key;  

  Reg = new TRegistry;  
  try {
    Reg->RootKey = HKEY_CURRENT_USER;
    Key = REG_SAVE;
    if (Reg->OpenKey(Key, False)) {
      SMTPHostEdit->Text = Reg->ReadString("SMTPHost");
      SMTPPortEdit->Value = Reg->ReadInteger("SMTPPort");

      FromAddressEdit->Text = Reg->ReadString("FromAddress");
      FromNameEdit->Text = Reg->ReadString("FromName");
      FromCompanyEdit->Text = Reg->ReadString("FromOrganization");
      ToEdit->Text = Reg->ReadString("To");
      CCEdit->Text = Reg->ReadString("ToCC");
      BCCEdit->Text = Reg->ReadString("ToBCC");

      CharsetEdit->Text = Reg->ReadString("Charset");
      PlainBox->Checked = Reg->ReadBool("PlainText");
      HTMLBox->Checked = !(PlainBox->Checked);
      PriorityBox->ItemIndex = Reg->ReadInteger("Priority");

      SubjectEdit->Text = Reg->ReadString("Subject");
      Memo1->Text = Reg->ReadString("MsgBody");

      AttachTypeBox->Checked = Reg->ReadBool("AttachType");
    }
  } catch (Exception &E) {
  }
  delete Reg;
}   

void __fastcall TForm1::StoreSettings()
{
  TRegistry  *Reg;
  AnsiString Key;  

  Reg = new TRegistry;  
  try {
    Reg->RootKey = HKEY_CURRENT_USER;
    Key = REG_SAVE;
    if (Reg->OpenKey(Key, True)) {
      Reg->WriteString("SMTPHost", SMTPHostEdit->Text);
      Reg->WriteInteger("SMTPPort", SMTPPortEdit->Value);

      Reg->WriteString("FromAddress", FromAddressEdit->Text);
      Reg->WriteString("FromName", FromNameEdit->Text);
      Reg->WriteString("FromOrganization", FromCompanyEdit->Text);
      Reg->WriteString("To", ToEdit->Text);
      Reg->WriteString("ToCC", CCEdit->Text);
      Reg->WriteString("ToBCC", BCCEdit->Text);

      Reg->WriteString("Charset", CharsetEdit->Text);
      Reg->WriteBool("PlainText", PlainBox->Checked);
      Reg->WriteInteger("Priority", PriorityBox->ItemIndex);

      Reg->WriteString("Subject", SubjectEdit->Text);
      Reg->WriteString("MsgBody", Memo1->Text);

      Reg->WriteBool("AttachType", AttachTypeBox->Checked);
    }
  } catch (Exception &E) {
  }
  delete Reg;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  PriorityBox->ItemIndex = 2;
  OpenDialog1->InitialDir = acSystemInfo1->DirDesktop;
  LoadSettings();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  StoreSettings();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SendBtnClick(TObject *Sender)
{
  PrepareSendMail();
  acSendMail1->Send();
  FixButtonState();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AbortBtnClick(TObject *Sender)
{
  acSendMail1->Abort();
  FixButtonState();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AttachBtnClick(TObject *Sender)
{
  int I;
  TListItem *AttachItem;

  if (OpenDialog1->Execute()) {
    OpenDialog1->InitialDir = ExtractFilePath(OpenDialog1->FileName);

    if (OpenDialog1->Files->Count != 0) {
      AttachPanel->Visible = True;
      for (I = 0; I < OpenDialog1->Files->Count; I++) {
        AttachItem = AttachView->Items->Add();
        AttachItem->Caption = ExtractFileName(OpenDialog1->Files->Strings[I]) +
            " (" + FileSizeToStr(OpenDialog1->Files->Strings[I], " bytes", " KB", " MB") + ")";
        AttachItem->ImageIndex = ImageList1->Count;

        // image
        acExtAssociation1->EXTENSION = ExtractFileExt(OpenDialog1->Files->Strings[I]);
        ImageList1->AddIcon(acExtAssociation1->SmallIcon);

        // attach
        acSendMail1->Attach->Add(OpenDialog1->Files->Strings[I]);
      }  

     AttachView->Update();
     while ((AttachView->IsScrollBarsVisible()) & (AttachPanel->Height < 60)) {
       AttachPanel->Height = AttachPanel->Height + 24;
     }
    }
  }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AttachViewChange(TObject *Sender, TListItem *Item,
      TItemChange Change)
{
  Open1->Enabled = AttachView->Selected != NULL;
  Print1->Enabled = Open1->Enabled;
  Remove1->Enabled = Open1->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
  if (AttachView->Selected != NULL) {
    ShellExecute(GetDesktopWindow(),
      (Sender == Print1) ? "print" : "open",
      acSendMail1->Attach->Strings[AttachView->Selected->Index].c_str(),
      "", "", SW_SHOWNORMAL);
  }    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Remove1Click(TObject *Sender)
{
  int I;

  if (AttachView->Selected != NULL) {
    for (I = AttachView->Items->Count - 1; I > 0; I--) {
      if (AttachView->Items->Item[I]->Selected) {
        acSendMail1->Attach->Delete(I);
        AttachView->Items->Delete(AttachView->Selected->Index);
      }
    }    
    AttachPanel->Visible = AttachView->Items->Count != 0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveBtnClick(TObject *Sender)
{
  if (SaveDialog->Execute()) {
    PrepareSendMail();
    acSendMail1->SaveToFile(SaveDialog->FileName, True);
  }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1Response(TObject *Sender, int Code,
      AnsiString Response)
{
  StatusList->Items->Add(Response);
  StatusList->ItemIndex = StatusList->Items->Count - 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1HostUnreachable(TObject *Sender)
{
  Application->MessageBox("Specified SMTP server is unreachable.\r\n\n"
                          "Please check your Internet connection\r\n"
                          "or specify another SMTP host or/and port.",
                          "Host unreachable", MB_OK || MB_ICONSTOP);
  SMTPHostEdit->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1SMTPError(TObject *Sender, int Code,
      AnsiString Response)
{
  StatusList->Items->Add("ERROR: " + Response);
  StatusList->ItemIndex = StatusList->Items->Count - 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1Progress(TObject *Sender,
      int MessageSize, int BytesSent, BYTE PercentsDone)
{
  ProgressBar1->Position = PercentsDone;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1ConnLost(TObject *Sender)
{
  ShowMessage("Connection Lost!");        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1Success(TObject *Sender)
{
  FixButtonState();
  ShowMessage("Message sent!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::acSendMail1AnyError(TObject *Sender)
{
  FixButtonState();        
}
//---------------------------------------------------------------------------

